--- old/usr/src/uts/common/fs/zfs/dmu.c	Tue Aug 27 12:59:20 2013
+++ new/usr/src/uts/common/fs/zfs/dmu.c	Tue Aug 27 12:59:20 2013
@@ -673,6 +673,16 @@
 	if (err != 0)
 		return (err);
 	err = dmu_free_long_range_impl(os, dn, offset, length);
+
+	/*
+	 * It is important to zero out the maxblkid when freeing the entire
+	 * file, so that (a) subsequent calls to dmu_free_long_range_impl()
+	 * will take the fast path, and (b) dnode_reallocate() can verify
+	 * that the entire file has been freed.
+	 */
+	if (offset == 0 && length == DMU_OBJECT_END)
+		dn->dn_maxblkid = 0;
+
 	dnode_rele(dn, FTAG);
 	return (err);
 }
